BEX= {}

SLASH_BEX1, SLASH_BEX2 = '/bage', '/bagexport';
local function handler(msg, editbox)
	if msg == '0' then
		BEX.DumpBags(0)
	elseif msg == '1' then
		BEX.DumpBags(1)
	elseif msg == '2' then
		BEX.DumpBags(2)
	elseif msg == '3' then
		BEX.DumpBags(3)
	elseif msg == '4' then
		BEX.DumpBags(4)
	elseif msg == 'all' then
		BEX.DumpAllBags()
	elseif msg == 'success' then
		BEX.BCDSuc()
	elseif msg == 'failed' then
		BEX.BCDFai()
	elseif msg == 'complete' then
		BEX.BCDCom()
	else
		print("Not a valid option.  Use '0', '1', '2', '3', '4', 'all', 'success', 'failed' or 'complete'.")
	end
end
SlashCmdList["BEX"] = handler;

local PaneBackdrop  = {
	bgFile = [[Interface\DialogFrame\UI-DialogBox-Background]],
	edgeFile = [[Interface\DialogFrame\UI-DialogBox-Border]],
	tile = true, tileSize = 16, edgeSize = 16,
	insets = { left = 3, right = 3, top = 5, bottom = 3 }
}

BEX.BagT = {}
BEX.BCT = {}
BEX.bcd = {}

function BEX.DisplayTextDump(BorB)

	local textdump

	-- If we don't send in a RecipeDB and profession, just dump the text
	if BorB == "BC" then
		textdump = BEX.GetTextDump("BC")
	elseif BorB == "Bag" then
		textdump = BEX.GetTextDump("Bag")
	elseif BorB == "Prof" then
		textdump = BEX.GetTextDump("Prof")
	elseif BorB == "bcd" then
		textdump = BEX.GetTextDump("bcd")
	end

	-- If we haven't created these frames, then lets do so now.
	if (not BEX.BEXCopyFrame) then
		BEX.BEXCopyFrame = CreateFrame("Frame", "BEXCopyFrame", UIParent)
		tinsert(UISpecialFrames, "BEXCopyFrame")
		BEX.BEXCopyFrame:SetBackdrop(PaneBackdrop)
		BEX.BEXCopyFrame:SetBackdropColor(0,0,0,1)
		BEX.BEXCopyFrame:SetWidth(750)
		BEX.BEXCopyFrame:SetHeight(400)
		BEX.BEXCopyFrame:SetPoint("CENTER", UIParent, "CENTER")
		BEX.BEXCopyFrame:SetFrameStrata("DIALOG")
		
		local scrollArea = CreateFrame("ScrollFrame", "BEXCopyScroll", BEX.BEXCopyFrame, "UIPanelScrollFrameTemplate")
		scrollArea:SetPoint("TOPLEFT", BEX.BEXCopyFrame, "TOPLEFT", 8, -30)
		scrollArea:SetPoint("BOTTOMRIGHT", BEX.BEXCopyFrame, "BOTTOMRIGHT", -30, 8)
		
		BEX.BEXCopyFrame.editBox = CreateFrame("EditBox", "BEXCopyEdit", BEX.BEXCopyFrame)
		BEX.BEXCopyFrame.editBox:SetMultiLine(true)
		BEX.BEXCopyFrame.editBox:SetMaxLetters(999999)
		BEX.BEXCopyFrame.editBox:EnableMouse(true)
		BEX.BEXCopyFrame.editBox:SetAutoFocus(true)
		BEX.BEXCopyFrame.editBox:SetFontObject(ChatFontNormal)
		BEX.BEXCopyFrame.editBox:SetWidth(650)
		BEX.BEXCopyFrame.editBox:SetHeight(270)
		BEX.BEXCopyFrame.editBox:SetScript("OnEscapePressed", function() BEX.BEXCopyFrame:Hide() end)
		BEX.BEXCopyFrame.editBox:SetText(textdump)
		BEX.BEXCopyFrame.editBox:HighlightText(0)
		
		scrollArea:SetScrollChild(BEX.BEXCopyFrame.editBox)
		
		local close = CreateFrame("Button", nil, BEX.BEXCopyFrame, "UIPanelCloseButton")
		close:SetPoint("TOPRIGHT", BEX.BEXCopyFrame, "TOPRIGHT")
		
		BEX.BEXCopyFrame:Show()
	else
		BEX.BEXCopyFrame.editBox:SetText(textdump)
		BEX.BEXCopyFrame.editBox:HighlightText(0)
		BEX.BEXCopyFrame:Show()
	end

end

function BEX.GetTextDump(BorB)
	local texttable = {}
	local tinsert = table.insert
	texttable = table.wipe(texttable)
	
	if BorB == "Bag" then
		tinsert(texttable,"ItemID,ItemName,Qty\n")
		
		for i,v in pairs(BEX.BagT) do
			tinsert(texttable,v.."\n")
		end
		
		return table.concat(texttable,"")
	elseif BorB == "BC" then
		
		tinsert(texttable,"ItemName,AuctionStatus,Profit,StackSize,ProfitPer,Fee,Time\n")
		
		for i,v in pairs(BEX.BCT) do
			tinsert(texttable,v.."\n")
		end
		
		return table.concat(texttable,"")
	elseif BorB == "Prof" then
	
		tinsert(texttable,"ProfID,ItemName\n")
		
		for i,v in pairs(BEX.Prof) do
			tinsert(texttable,v.."\n")
		end
		
		return table.concat(texttable,"")
	elseif BorB == "bcd" then
	
		tinsert(texttable,"ItemID,ItemName,AuctionStatus,StackSize,Money,Deposit,Fee,Buyout,Bid,Time\n")
		
		for i,v in pairs(BEX.bcd) do
			tinsert(texttable,v.."\n")
		end
		
		return table.concat(texttable,"")
	end
end

function BEX.DumpBags(Bag)
	local e=0
	if Bag==0 then
		e=0
	elseif Bag==1 then
		e=1
	elseif Bag==2 then
		e=2
	elseif Bag==3 then
		e=3
	elseif Bag==4 then
		e=4
	end
	local s=GetContainerNumSlots(e)
	local w=s
	local tinsert=table.insert
	BEX.BagT = table.wipe(BEX.BagT)
	
	for x=1,s do
		local _,c,_,_,_,_,l=GetContainerItemInfo(e,w)
			if c==nil then
				w=w-1
			else
				local _,_,q=strsplit("|", l)
				local _,a=strsplit(":",q)
				tinsert(BEX.BagT, a..","..l..","..c)
				w=w-1
			end
	end
	BEX.DisplayTextDump("Bag")
end

function BEX.DumpAllBags()
	local s=GetContainerNumSlots(0)
	local w=s
	local tinsert=table.insert
	BEX.BagT = table.wipe(BEX.BagT)
	
	for v=1,s do
		local _,c,_,_,_,_,l=GetContainerItemInfo(0,w)
			if c==nil then
				w=w-1
			else
				local _,_,q=strsplit("|", l)
				local _,a=strsplit(":",q)
				tinsert(BEX.BagT, a..","..l..","..c)
				w=w-1
			end
	end
	s=GetContainerNumSlots(1)
	w=s
	for w=1,s do
		local _,c,_,_,_,_,l=GetContainerItemInfo(1,w)
			if c==nil then
				w=w-1
			else
				local _,_,q=strsplit("|", l)
				local _,a=strsplit(":",q)
				tinsert(BEX.BagT, a..","..l..","..c)
				w=w-1
			end
	end
	s=GetContainerNumSlots(2)
	w=s
	for x=1,s do
		local _,c,_,_,_,_,l=GetContainerItemInfo(2,w)
			if c==nil then
				w=w-1
			else
				local _,_,q=strsplit("|", l)
				local _,a=strsplit(":",q)
				tinsert(BEX.BagT, a..","..l..","..c)
				w=w-1
			end
	end
	s=GetContainerNumSlots(3)
	w=s
	for y=1,s do
		local _,c,_,_,_,_,l=GetContainerItemInfo(3,w)
			if c==nil then
				w=w-1
			else
				local _,_,q=strsplit("|", l)
				local _,a=strsplit(":",q)
				tinsert(BEX.BagT, a..","..l..","..c)
				w=w-1
			end
	end
	s=GetContainerNumSlots(4)
	w=s
	for z=1,s do
		local _,c,_,_,_,_,l=GetContainerItemInfo(4,w)
			if c==nil then
				w=w-1
			else
				local _,_,q=strsplit("|", l)
				local _,a=strsplit(":",q)
				tinsert(BEX.BagT, a..","..l..","..c)
				w=w-1
			end
	end
	BEX.DisplayTextDump("Bag")
end

function BEX.BCDSuc()
	local server = GetRealmName()
	local player = GetUnitName("player")
	BEX.bcd = table.wipe(BEX.bcd)
	
	for i,v in pairs(BeanCounterDB[server][player]) do
		if i == "completedAuctions" then
			local bcd = BeanCounterDB[server][player][i]
			if type(bcd) == "table" then
				for i2,v2 in pairs(bcd) do
					local n,_ = GetItemInfo(i2)
					for i3,v3 in pairs(bcd[i2]) do 
						for i4,v4 in pairs(bcd[i2][i3]) do
							local stack, money, deposit, fee, buyout, bid, _, atime = strsplit(";",v4)
							tinsert(BEX.bcd, i2..",["..n.."],AuctionSuccessful,"..stack..","..money..","..deposit..","..fee..","..buyout..","..bid..","..atime)
						end
					end
				end
			end
		end
	end
	BEX.DisplayTextDump("bcd")
end

function BEX.BCDFai()
	local server = GetRealmName()
	local player = GetUnitName("player")
	BEX.bcd = table.wipe(BEX.bcd)
	
	for i,v in pairs(BeanCounterDB[server][player]) do
		if i == "failedAuctions" then
			local bcd = BeanCounterDB[server][player][i]
			if type(bcd) == "table" then
				for i2,v2 in pairs(bcd) do
					local n,_ = GetItemInfo(i2)
					for i3,v3 in pairs(bcd[i2]) do 
						for i4,v4 in pairs(bcd[i2][i3]) do
							local stack, _, deposit, _, buyout, bid, _, atime=strsplit(";",v4)
							tinsert(BEX.bcd, i2..",["..n.."],AuctionFailed,"..stack..",0,"..deposit..",0,"..buyout..","..bid..","..atime)
						end
					end
				end
			end
		end
	end
	BEX.DisplayTextDump("bcd")
end

function BEX.BCDCom()
	local server = GetRealmName()
	local player = GetUnitName("player")
	BEX.bcd = table.wipe(BEX.bcd)

	for i,v in pairs(BeanCounterDB[server][player]) do
		if i == "completedBids/Buyouts" then
			local bcd = BeanCounterDB[server][player][i]
			if type(bcd) == "table" then
				for i2,v2 in pairs(bcd) do
					local n,_ = GetItemInfo(i2)
					for i3,v3 in pairs(bcd[i2]) do 
						for i4,v4 in pairs(bcd[i2][i3]) do
							local stack, money, deposit, fee, buyout, bid, _, atime = strsplit(";",v4)
							tinsert(BEX.bcd, i2..",["..n.."],AuctionWon,"..stack..","..money..","..deposit..","..fee..","..buyout..","..bid..","..atime)
						end
					end
				end
			end
		end
	end
	BEX.DisplayTextDump("bcd")
end